/* $Id: plist.h,v 1.3 2002/09/27 14:54:17 aa5779 Exp $ */
/*
 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef PLIST_H
#define PLIST_H

#include "dstring.h"
#include "interp.h"

#ifndef PLIST_IMP
extern storage_class plist_storage_class;
#endif

storage *plist_create(interpreter *i, char *name, char *arg);

void plist_destroy(interpreter *i, storage *s);

int plist_check(interpreter *i, storage *s, dstring *key);
dstring *plist_get(interpreter *i, storage *s, dstring *key);

void plist_put(interpreter *i, storage *s, dstring *key, dstring *val);
void plist_add(interpreter *i, storage *s, dstring *key, dstring *val);

void plist_remove(interpreter *i, storage *s, dstring *key);

dstring *plist_first(interpreter *i, storage *s, void **iter);
dstring *plist_next(interpreter *i, storage *s, void **iter);
void plist_enditer(interpreter *i, storage *s, void **iter);

int plist_numofitems(interpreter *i, storage *s);
dstring *plist_seek(interpreter *i, storage *s, void **iter, dstring *key);

#endif
